# VC++ prefills new heap and stack objects with 0xcccccccc. This script
# allows you to modify the compiled DLL (assuming Brew here) and prefill with
# 0's instead

use File::Temp qw/ tempfile /;

$dll_path = shift;

unless(defined $dll_path) {
   print "Usage: mod_dll.py <dllpath>\n";
   exit 1;
}

open infile, "< $dll_path" or die "$!: Could not open $dll_path";
# Open a temporary file
($outfileH, $outfile) = tempfile( DIR => "/tmp" );

# Access both files in binary mode
binmode infile;
binmode $outfileH;

# read 4 bytes, non-aligned
$cnt = 0;
$cc = pack "C", 0xcc;
while(!eof infile)
{
   $len = read infile, $data, 1;
   if($data eq $cc)
   {
      $cnt += 1;
      # 4 contiguous bytes of 0xcc (i.e. 0xcccccccc) implies a stack fill.
      if($cnt == 4)
      {
         # Replace it with our value of choice
         $data = pack "I", 0x00000000;
         print $outfileH $data;
         # Reset the match coubnt
         $cnt = 0;
      }
   }
   else
   {
      # Not 0xcc. 
      while($cnt > 0)
      {
         # So write out any previously matched 0xcc's
	 print $outfileH $cc;
         $cnt -= 1;
      }
      # Write out the current byte
      print $outfileH $data;
   }
}
close infile;
close $outfileH;

# Overwrite infile with outfile
unlink $dll_path;
rename $outfile, $dll_path;
